# TODO: verify gdb pretty-printers location
#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs
%bcond_without	static_libs	# don't build static libraries

Summary:	Library for manipulating sets and relations of integer points bounded by linear constraints
Summary(pl.UTF-8):	Biblioteka operacji na zbiorach i relacjach punktów całkowitoliczbowych z ograniczeniami liniowymi
Name:		isl
Version:	0.26
Release:	1
License:	MIT
Group:		Libraries
Source0:	https://libisl.sourceforge.io/%{name}-%{version}.tar.xz
# Source0-md5:	f2b56e8da688eba89838d414470da85f
Patch0:		%{name}-opt.patch
URL:		https://libisl.sourceforge.io/
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	gmp-devel
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	libtool >= 2:1.5
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpm-pythonprov
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
%if %{with apidocs}
BuildRequires:	perl-base
BuildRequires:	perl-tools-pod
BuildRequires:	texlive-format-pdflatex
%endif
# clang can be used to generate interface/isl.py, which is not used afterwards
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# see m4/ax_cc_maxopt.m4
%define		specflags	-fomit-frame-pointer -fstrict-aliasing -ffast-math
%define		specflags_ia32	-malign-double

%description
isl is a library for manipulating sets and relations of integer points
bounded by linear constraints. Supported operations on sets include
intersection, union, set difference, emptiness check, convex hull,
(integer) affine hull, integer projection, and computing the
lexicographic minimum using parametric integer programming. It also
includes an ILP solver based on generalized basis reduction.

%description -l pl.UTF-8
isl to biblioteka do operacji na zbiorach i relacjach punktów
całkowitoliczbowych z ograniczeniami liniowymi. Obsługiwane operacje
na zbiorach obejmują przecięcia, sumy, różnice, sprawdzanie, czy zbiór
jest pusty, wyznaczanie powłoki wypukłej, wyznaczanie
(całkowitoliczbowej) powłoki afinicznej, rzuty całkowitoliczbowe oraz
obliczanie minimum leksykograficznego przy użyciu parametrycznego
programowania liniowego. Biblioteka obsługuje także rozwiazywanie
całkowitoliczbowych problemów liniowych w oparciu o redukcję bazy.

%package devel
Summary:	Header files for isl library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki isl
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	gmp-devel

%description devel
Header files for isl library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki isl.

%package static
Summary:	Static isl library
Summary(pl.UTF-8):	Statyczna biblioteka isl
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static isl library.

%description static -l pl.UTF-8
Statyczna biblioteka isl.

%package apidocs
Summary:	isl API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki isl
Group:		Documentation
BuildArch:	noarch

%description apidocs
API and internal documentation for isl library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki isl.

%package gdb
Summary:	GDB Python pretty printers for isl types
Summary(pl.UTF-8):	Skrypty Pythona dla GDB do ładnego wypisywania typów isl
Group:		Development/Debuggers
Requires:	gdb

%description gdb
GDB Python pretty printers for most of isl objects.

%description gdb -l pl.UTF-8
Skrypty Pythona dla GDB do ładnego wypisywania większości obiektów
isl.

%prep
%setup -q
%patch0 -p1

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--enable-portable-binary \
	--disable-silent-rules

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load/usr/%{_lib}
%{__mv} $RPM_BUILD_ROOT%{_libdir}/libisl.so.*.*.*-gdb.py $RPM_BUILD_ROOT%{_datadir}/gdb/auto-load/usr/%{_lib}

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libisl.la

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog
%attr(755,root,root) %{_libdir}/libisl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libisl.so.23

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libisl.so
%{_includedir}/isl
%{_pkgconfigdir}/isl.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libisl.a

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc doc/manual.pdf
%endif

%files gdb
%defattr(644,root,root,755)
%{_datadir}/gdb/auto-load/usr/%{_lib}/libisl.so.*.*.*-gdb.py
%changelog
* Mon Jun 26 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/isl.git;a=log;h=master

* Mon Jun 26 2023 Jakub Bogusz <qboosh@pld-linux.org> fba08b5
- updated to 0.26

* Tue Feb 15 2022 Jakub Bogusz <qboosh@pld-linux.org> 92db16f
- updated to 0.24 (new soname)
- added opt patch, build portable library with optflags based on distro defaults

* Sun Nov 01 2020 Jakub Bogusz <qboosh@pld-linux.org> 04b3d11
- updated to 0.22.1 (new soname)

* Tue Feb 15 2022 Jakub Bogusz <qboosh@pld-linux.org> 420d7b9
- rpm version for noarch subpackage

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 17b2b1e
- unconditional noarch subpackages

* Fri Oct 11 2019 Jakub Bogusz <qboosh@pld-linux.org> 02da0eb
- updated to 0.21 (note: new soname)

* Sun Apr 01 2018 Jakub Bogusz <qboosh@pld-linux.org> 31e88d6
- updated to 0.19 (note: new soname)

* Mon Jun 12 2017 Jakub Bogusz <qboosh@pld-linux.org> fb72ef9
- updated to 0.18

* Tue May 10 2016 Jakub Bogusz <qboosh@pld-linux.org> ecc9c1a
- updated to 0.17.1 (note: 0.16.1 officially supported by gcc 5/6 left on isl-0.16 branch; 0.17.x should be compatible though)

* Tue May 10 2016 Jakub Bogusz <qboosh@pld-linux.org> af91339
- updated to 0.16.1

* Sat Sep 12 2015 Jakub Bogusz <qboosh@pld-linux.org> 29c1b0a
- updated to 0.15 (note: new soname; for gcc 5.1/5.2 or so)

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> cc881d9
- x32 rebuild
- release 2 (by relup.sh)

* Thu Jan 15 2015 Jakub Bogusz <qboosh@pld-linux.org> ffae7c4
- updated to 0.14

* Fri Apr 18 2014 Jakub Bogusz <qboosh@pld-linux.org> e6c3b41
- updated to 0.13 (note: new soname; piplib support dropped)

* Thu Apr 03 2014 Elan Ruusamäe <glen@delfi.ee> 775d59d
- noarch apidocs

* Sun Feb 16 2014 Jakub Bogusz <qboosh@pld-linux.org> 17de6a2
- new Source0 URL, updated to 0.12.2

* Wed Aug 21 2013 Jakub Bogusz <qboosh@pld-linux.org> a88c6b7
- updated to 0.12.1

* Tue Jul 09 2013 Jakub Bogusz <qboosh@pld-linux.org> 3d3bfcf
- updated to 0.12

* Sat Apr 13 2013 Jakub Bogusz <qboosh@pld-linux.org> b40319d
- updated to 0.11.2

* Thu Dec 13 2012 Jakub Bogusz <qboosh@pld-linux.org> 8e3fc5e
- updated to 0.11.1

